## graphicsmagick 1.3.5-1

=== debian/changelog ===
graphicsmagick (1.3.5-1) unstable; urgency=low

  * Initial release for maemo.

 -- Terrence Fleury <terrencegf@gmail.com>  Fri, 30 Jan 2009 09:12:59 -0600
