=== debian/control ===
Source: graphicsmagick
Section: user/graphics
Priority: extra
Maintainer: Terrence Fleury <terrencegf@gmail.com>
Build-Depends: debhelper (>= 5), autoconf, autotools-dev
Standards-Version: 3.7.2

Package: graphicsmagick
Architecture: any
Depends: ${shlibs:Depends}
Description: Collection of image processing tools
 GraphicsMagick provides a set of command-line applications to manipulate
 image files. It is a fork of the ImageMagick project and therefore offers
 a similar set of features, but puts a larger emphasis on stability.
 .
 The tools support a large variety of image formats from the widely used
 jpeg, tiff, bmp, or xpm to special-purpose formats such as fits or image
 formats found on some photo CDs. They can convert between formats,
 concatenate several images into one, annotate and distort them, create
 thumbnails, or manipulate the colormap. While all features are available
 from the command-line, the package also includes an image viewer that
 allows interactive manipulation.
 .
 Note that unlike ImageMagick, the GraphicsMagick tools are accessed
 through a single executable called 'gm'. Therefore, GraphicsMagick and
 ImageMagick can be used in parallel.
 .
 Homepage: http://www.graphicsmagick.org/
XB-Maemo-Display-Name: GraphicsMagick
XB-Maemo-Icon-26:
 VBORw0KGgoAAAANSUhEUgAAABoAAAAaCAMAAACelLz8AAADAFBMVEXJ26YAm0ZY
 W1rIyMi3z4eQtUampqY2UAAYLQVNcwCCg4IAaS9diwDe58sAUyUJEwMoKyk4bVA4
 QTxUk3ECPRz///9wnxDy9esAgTp5piCDrDCkwmcAsE9mmQAAAAD///8AAAAAAAAA
 AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
 AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
 AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
 AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
 AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
 AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
 AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
 AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
 AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
 AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
 AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
 AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
 AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
 AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAADluXdnAAAA
 CXBIWXMAAAsSAAALEgHS3X78AAABSklEQVR4nH2S646CMBSEx1o3XMRKozabvv+j
 NQZ0i6xBLiUn20p0V43LH6DfzLQMh2/x7uJvyR3VEKzEjl4RcyCS7Tl9RUdIK1k2
 MHpBWHBwIlYuo2eU9IiJVZk2CT2hy/yL4Sis1qV4RIzWaLEZNOC66AFViBHv1yd/
 QA1Hf1DtvByfwOjfq07+oon4ZW286aKsuKHOqdHfCmgTJBrZ3dVPS4obBEmV26kv
 /5xDX1Wj9qHGfwjGNj6LgKiUIa3QV6HfD1bD1iIcIytixYMn0BFTSE4BDWve8CG/
 hgY/jDZL8hGsAq9zGluLsJMq7KjGha+SNyuH9DSzm1lygTxt3Y7qAih1yTOnCiNt
 cpxjIQttVN+kqbf7Bogf5MAEQqnWV1So5qPukdicgyRuXQu4eHVIKIo6saeniaLs
 exOqiJx8GTZKp19C/87hD+WZkrKh66EPAAAAAElFTkSuQmCC
