## graphicsmagick 1.3.5-2

=== debian/changelog ===
graphicsmagick (1.3.5-2) unstable; urgency=low

  * Try forcing --with-x to enable "display" command.

 -- Terrence Fleury <terrencegf@gmail.com>  Fri, 30 Jan 2009 16:53:00 -0600
