=== debian/control ===
--- 
+++ 
@@ -28,7 +28,7 @@
  Homepage: http://www.graphicsmagick.org/
 XB-Maemo-Display-Name: GraphicsMagick
 XB-Maemo-Icon-26:
- VBORw0KGgoAAAANSUhEUgAAABoAAAAaCAMAAACelLz8AAADAFBMVEXJ26YAm0ZY
+ iVBORw0KGgoAAAANSUhEUgAAABoAAAAaCAMAAACelLz8AAADAFBMVEXJ26YAm0ZY
  W1rIyMi3z4eQtUampqY2UAAYLQVNcwCCg4IAaS9diwDe58sAUyUJEwMoKyk4bVA4
  QTxUk3ECPRz///9wnxDy9esAgTp5piCDrDCkwmcAsE9mmQAAAAD///8AAAAAAAAA
  AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
