## graphicsmagick 1.3.5-3

=== debian/changelog ===
graphicsmagick (1.3.5-3) unstable; urgency=low

  * Added libx11-dev to Build-depends to try to get "display" command.

 -- Terrence Fleury <terrencegf@gmail.com>  Fri, 30 Jan 2009 19:35:00 -0600
