## graphicsmagick 1.3.5-4

=== debian/changelog ===
graphicsmagick (1.3.5-4) unstable; urgency=low

  * Added a bunch of lib...-devs to Build-depends.

 -- Terrence Fleury <terrencegf@gmail.com>  Fri, 30 Jan 2009 20:37:00 -0600
