=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: user/graphics
 Priority: extra
 Maintainer: Terrence Fleury <terrencegf@gmail.com>
-Build-Depends: debhelper (>= 5), autoconf, autotools-dev, libx11-dev
+Build-Depends: debhelper (>= 5), autoconf, autotools-dev, libbz2-dev, libfreetype6-dev, libjpeg-dev, libpng-dev, libtiff-dev, libx11-dev, libxml2-dev, libz-dev
 Standards-Version: 3.7.2
 
 Package: graphicsmagick
