## graphicsmagick 1.3.5-5

=== debian/changelog ===
graphicsmagick (1.3.5-5) unstable; urgency=low

  * Added libxext-devs to Build-depends.

 -- Terrence Fleury <terrencegf@gmail.com>  Fri, 30 Jan 2009 20:37:00 -0600
